#!/usr/bin/env python
# dirstat.py - show file statistics for a given directory
# @author filipp@mekanisti.fi

import os, sys, commands, traceback, mimetypes
from subprocess import Popen

usage = "Usage: " + os.path.basename(sys.argv[0]) + " directory"

if len (sys.argv) < 2:
	print usage
	sys.exit (1)

path = sys.argv[1]

if (os.path.isdir(path) == False):
	print "Invalid path"
	print usage
	sys.exit(1)
	
c = {}
s = {}
l = {}

def getDir(arg, dirname, names):
	for file in names:
		ext = os.path.splitext(file)[1]
		
		if (ext != "" and file != ext): # Don't want hidden and typeless files
			fp = os.path.join(dirname, file)
			
			if os.path.isfile(fp):
				f = open(fp)
				size = os.lstat(fp).st_size
				
				try:
					mt = mimetypes.guess_type(fp)[0]
					
					if (mt != None):
						mt = mt.split("/")[0]
					
					if (mt != "image"):
						lc = sum(1 for line in f)
					else:
						lc = 0
					
					c[ext] = c.get(ext, 0) + 1
					s[ext] = s.get(ext, 0) + size
					l[ext] = l.get(ext, 0) + int(lc)
						
				except:
					pass

print "\n * Gathering information for \"%s\"" % path

os.path.walk(path, getDir, None)
tlines = sum(l.values())

print "\nExtension\tFiles\tSize\tLines\t%"
print 80 * "-"

for f in c.keys ():
	pct =  float(l[f])/tlines * 100
	print "%s\t\t%d\t%d\t%d\t%.2f" % (f, c[f], s[f] / 1024, l[f], pct)
